
#include "bitboard.h"
#include "position.h"

//ԍ͔Ղ̍ォ牡[0-81)

Bitboard SquareBB[SquareNum];
Bitboard StepAttacksBB[ColorNum][ProGold][SquareNum];

Bitboard SlidingAttacksBB[SquareNum][SlidingTypeNum + 2][1 << (FileNum - 2)];
Occupied SquareOcc[SquareNum];
uint8_t OccShift[SquareNum][SlidingTypeNum];

Bitboard MoveTwiceBB[ColorNum][SquareNum][ProGold];
Bitboard ToKingsubBB[ColorNum][SquareNum][ProPawnEx + 1];

Bitboard InFrontBB[ColorNum][RankNum + 1];
Bitboard PawnFileBB[1 << FileNum];
Bitboard FileBB[FileNum], RankBB[RankNum];
Bitboard BetweenBB[SquareNum][SquareNum];
int8_t Direction[SquareNum][SquareNum];

void init_bitboards() {
    for (Square s = SQ_9A; s < SquareNum; ++s) {
        SquareBB[s] = Bitboard{ s };
    }

    for (int x = 0; x < FileNum; ++x) {
        Bitboard b = ZeroBB;
        for (int y = 0; y < RankNum; y++) {
            b |= SquareBB[square(x, y)];
        }
        FileBB[x] = b;
    }

    for (int y = 0; y < RankNum; ++y) {
        Bitboard b = ZeroBB;
        for (int x = 0; x < FileNum; ++x) {
            b |= SquareBB[square(x, y)];
        }
        RankBB[y] = b;
    }

    InFrontBB[Black][0] = InFrontBB[White][0] = ZeroBB;
    for (int y = 0; y < RankNum; y++) {
        InFrontBB[Black][y + 1] = InFrontBB[Black][y] ^ RankBB[RankInv(Black, y)];
        InFrontBB[White][y + 1] = InFrontBB[White][y] ^ RankBB[RankInv(White, y)];
    }

    for (int k = 0; k < _countof(PawnFileBB); ++k) {
        Bitboard b = ZeroBB;
        for (int x = 0; x < FileNum; ++x) {
            if (!(k & 1 << x)) b ^= FileBB[x];
        }
        PawnFileBB[k] = b;
    }

    constexpr int8_t N = FileNum;
    constexpr int8_t Attacks[ProGold][9] = {
        { -N - 1, -N, -N + 1, -1, 1, N - 1, N, N + 1, 0 },//
        { -N, -1, 1, N, 0, 0, 0, 0, 0 },
        { -N - 1, -N + 1, N - 1, N + 1, 0, 0, 0, 0, 0 },
        { -N - 1, -N, -N + 1, -1, 1, N, 0, 0, 0 },//AGolds
        { -N - 1, -N, -N + 1, N - 1, N + 1, 0, 0, 0, 0 },
        { -N * 2 + 1, -N * 2 - 1, 0, 0, 0, 0, 0, 0, 0 },
        { -N, 0, 0, 0, 0, 0, 0, 0, 0 },
        { -N, 0, 0, 0, 0, 0, 0, 0, 0 },//
        { 0, 0, 0, 0, 0, 0, 0, 0, 0 },
        { -N - 1, -N + 1, N - 1, N + 1, -N, -1, 1, N, 0 },//
        { -N, -1, 1, N, -N - 1, -N + 1, N - 1, N + 1, 0 },
    };
    for (Color c = Black; c < ColorNum; ++c) {
        for (PieceType p = King; p < ProGold; ++p) {
            for (Square sq = SQ_9A; sq < SquareNum; ++sq) {
                Bitboard b = ZeroBB;
                for (int i = 0; Attacks[p][i]; i++) {
                    Square to = sq + Attacks[p][i] * ColorToSign(c);
                    //їȊOŉ2ȏ㓮͂Ȃ
                    if (0 <= to && to < SquareNum && abs(int(sq % FileNum) - int(to % FileNum)) <= 1) b |= SquareBB[to];
                }
                StepAttacksBB[c][p][sq] = b;
            }
        }
    }

    //sq:[0-81), j:̕[0-4)
    for (int j = 0; j < 4; ++j) {
        for (Square sq = SQ_9A; sq < SquareNum; ++sq) {
            //o:occł̎n_[0-64), l:occł̒(0-9], r:l̒̉Ԗ[0-l), sq:
            int o, l, r;
            int x = sq % FileNum;
            int y = sq / FileNum;

            switch (j) {
                case 0://c
                    o = x * (RankNum - 2);
                    l = RankNum;
                    r = y;
                    break;
                case 1://
                    o = y * (FileNum - 2);//7bitlߍł(S63bit)
                    l = FileNum;
                    r = x;
                    break;
                case 2://ii
                case 3:
                    int m, n;//m:ii̍W[0-16], n:Ղ̒0ɂ[(-8)-(+8)]
                    int _x;
                    _x = (j == 2) ? FileNum - 1 - x : x;
                    m = _x + y;
                    n = m - (FileNum - 1);
                    o = (m - 2) * (m - 1) / 2;//Ղii猩ĎOp`
                    if (n > 0) o -= n * (n - 1);//قƂ͎lp`Ȃ̂ŕ␳
                    if (m > 2) o += 3;//LbVqbgCオ邩H
                    if (m > 4) o += 4;
                    if (m > 12) o += 4;
                    if (m > 14) o += 3;
                    l = (n < 0) ? m + 1 : FileNum - n;//Ղ̒͗
                    r = y;//Ղ̏[琔
                    if (n > 0) r -= n;//E̒[琔
                    //sq = nFile + ((j == 2) ? 1 : -1);//m̃iiƂ͐(sq𑫂Ăm̒l͕ςȂ)
                    break;
                default:
                    __assume(0);
            }

            OccShift[sq][j] = static_cast<uint8_t>(o);

            //ɒ[łȂ MM64bitōς(63bit΂)
            SquareOcc[sq].m128i_[0].m128i_u64[j] = (0 < r && r < l - 1) ? 1ULL << (o + r - 1) : 0;

            //7128ʂSẴp^[ɂėSlidingAttacksBBvZ
            for (int k = 0; k < 1 << (FileNum - 2); ++k) {
                Bitboard b = ZeroBB;
                for (int m = r + 1; m < l; ++m) {
                    b |= SquareBB[sq + SlidingStep[j] * (m - r)];
                    if (k & 1 << (m - 1)) break;//[߂-1
                }
                for (int m = r - 1; m >= 0; --m) {
                    b |= SquareBB[sq + SlidingStep[j] * (m - r)];
                    if (k & 1 << (m - 1)) break;
                }
                SlidingAttacksBB[sq][j][k] = b;
                if (j == 0) {
                    //
                    for (Color c = Black; c < ColorNum; ++c) {
                        SlidingAttacksBB[sq][SlidingTypeNum + c][k] = SlidingAttacksBB[sq][j][k] & InFrontBB[c][RankInv(c, sq / FileNum)];
                    }
                }
            }
        }
    }

    for (Color c = Black; c < ColorNum; ++c) {
        for (Square sq = SQ_9A; sq < SquareNum; ++sq) {
            for (PieceType p = King; p < PieceTypeNum; ++p) {
                if (p == HandTypeNum) continue;

                if (p < ProGold) {
                    Bitboard fromBB = ZeroBB;
                    Bitboard toBB = step_attacks_bb(OppositeColor(c), p, sq);
                    if (CanPromote(p)) {
                        Bitboard proAttacksBB = step_attacks_bb(OppositeColor(c), CvtIfGolds(p + HandTypeNum), sq);
                        if (!InFrontBB[c][PromotionRank].isSet(sq)) proAttacksBB &= ~InFrontBB[c][PromotionRank];
                        toBB |= proAttacksBB;
                    }
                    for_each_bb(toBB, [&](const Square to) {
                        //pto֗sqւ̗(\)
                        fromBB |= attacks_bb(OppositeColor(c), to, p, ZeroOcc);
                    });
                    MoveTwiceBB[c][sq][p] = fromBB;
                }
                if (p <= ProPawnEx) {
                    Bitboard fromBB = ZeroBB;
                    Bitboard toBB = attacks_bb(OppositeColor(c), sq, King, ZeroOcc);
                    for_each_bb(toBB, [&](const Square to) {
                        fromBB |= (p < ProGold) ?
                            attacks_bb(OppositeColor(c), to, p, ZeroOcc) :
                            step_attacks_bb(OppositeColor(c), (p == DragonEx) ? Bishop : (p == HorseEx) ? Rook : Golds, to);
                    });
                    ToKingsubBB[c][sq][p] = fromBB;
                }
            }
        }
    }

    std::memset(BetweenBB, 0, sizeof BetweenBB);
    std::memset(Direction, 0, sizeof Direction);
    for (Square s1 = SQ_9A; s1 < SquareNum; ++s1) {
        for (int j = 0; j < 4; ++j) {
            for_each_bb(SlidingAttacksBB[s1][j][0], [&](const Square s2) {
                const int step = SlidingStep[j] * Sign(static_cast<int8_t>(s2 - s1));
                Bitboard b = ZeroBB;
                for (Square sq = s1 + step; sq != s2; sq += step) {
                    b |= SquareBB[sq];
                }
                BetweenBB[s1][s2] = b;
                Direction[s1][s2] = step;
            });
        }
    }
}

#ifdef DEBUG
std::string Bitboard::toString() const {
    std::string s;
    for (int y = 0; y < RankNum; ++y) {
        for (int x = 0; x < FileNum; ++x) {
            Square sq = square(x, y);
            s += isSet(sq) ? 'x' : '_';
        }
        s += '\n';
    }
    return s;
}
#endif

Bitboard::Bitboard(const Square sq) {
    m128i_ = _mm_setzero_si128();
    if (sq < SquareSecond) {
        m128i_.m128i_u64[0] = 1ULL << sq;
    } else {
        m128i_.m128i_u64[1] = 1ULL << (sq - SquareSecond);
    }
}
