
#pragma once

#include <intrin.h>
#include <cmath>
#include <cstdint>
#include <iostream>
#include <string>
#include <type_traits>

//#define DEBUG
//#define SEE_TEST
//#define MATE_TEST

#ifdef DEBUG
inline int aaa() { throw; return 0; }
#define assert(expression) (void)(                                                       \
            (!!(expression)) ||                                                              \
            (std::cout << "info string file:" << __FILE__ << " line:" << __LINE__ << std::endl, aaa()) \
        )
#else
#define RELEASE
#define assert(x) ((void)0)
//#define assert(x) __assume(x)
#endif

//#pragma inline_depth(255)
#define forceinline __forceinline

#ifdef _M_IX86

forceinline unsigned char _BitScanForward64(unsigned long *index, unsigned __int64 mask) {
    if (mask == 0) return 0;
    unsigned char u;
    u = _BitScanForward(index, static_cast<unsigned long>(mask));
    if (u != 0) return u;
    u = _BitScanForward(index, static_cast<unsigned long>(mask >> 32));
    *index += 32;
    return u;
}

forceinline unsigned char _BitScanReverse64(unsigned long *index, unsigned __int64 mask) {
    if (mask == 0) return 0;
    unsigned char u;
    u = _BitScanReverse(index, static_cast<unsigned long>(mask >> 32));
    if (u != 0) { *index += 32; return u; }
    u = _BitScanReverse(index, static_cast<unsigned long>(mask));
    return u;
}

forceinline unsigned __int64 __popcnt64(unsigned __int64 value) {
    return __popcnt(static_cast<unsigned int>(value)) + __popcnt(static_cast<unsigned int>(value >> 32));
}

#endif

//[n, n+k)bitԂ (:B(2, 3) == 0b11100)
forceinline constexpr uint64_t MaskBits(int n, int k) {
    return ((1ULL << k) - 1ULL) << n;
}

//v[n, n+k)ɂf[^Ԃ
template <int P, int K, class T>
forceinline constexpr T ExtBits(const T v) {
    return v >> P & (T{ 1 } << K) - 1;
}
template <class T>
forceinline constexpr T ExtBits(T v, int n, int k) {
    return v >> n & (T{ 1 } << k) - 1;
}

//2pɐ؂̂Ă
inline size_t ToPow2(const size_t m) {
    unsigned long i;
    unsigned char c = _BitScanReverse64(&i, m);
    return (c == 0) ? 0 : static_cast<size_t>(1) << i;
}

//template <class A, class T, int L>
//class ConstexprArrayHelper {
//    struct Array {
//        std::array<T, L> a;
//        template <class... Ts>
//        constexpr Array(Ts... i) : a{ i... } {}
//    };
//
//    template <int N, T... I>
//    struct Func {
//        constexpr static Array func() {
//            return Func<N - 1, I..., A{}(L - N)>::func();
//        }
//    };
//
//    template <T... I>
//    struct Func<0, I...> {//VC++2015Foo<L, I...>ƏƉG[ɂȂ
//        constexpr static Array func() {
//            return Array{ I... };
//        }
//    };
//
//public:
//    constexpr std::array<T, L> operator()() const {
//        return Func<L>::func().a;
//    }
//};

#define OverloadEnumOperators(T)                                        \
    forceinline void operator += (T& lhs, const int rhs) { lhs  = static_cast<T>(static_cast<int>(lhs) + rhs); } \
    forceinline void operator += (T& lhs, const T   rhs) { lhs += static_cast<int>(rhs); } \
    forceinline void operator -= (T& lhs, const int rhs) { lhs  = static_cast<T>(static_cast<int>(lhs) - rhs); } \
    forceinline void operator -= (T& lhs, const T   rhs) { lhs -= static_cast<int>(rhs); } \
    forceinline void operator *= (T& lhs, const int rhs) { lhs  = static_cast<T>(static_cast<int>(lhs) * rhs); } \
    forceinline void operator /= (T& lhs, const int rhs) { lhs  = static_cast<T>(static_cast<int>(lhs) / rhs); } \
    forceinline constexpr T operator + (const T   lhs, const int rhs) { return static_cast<T>(static_cast<int>(lhs) + rhs); } \
    forceinline constexpr T operator + (const T   lhs, const T   rhs) { return lhs + static_cast<int>(rhs); } \
    forceinline constexpr T operator - (const T   lhs, const int rhs) { return static_cast<T>(static_cast<int>(lhs) - rhs); } \
    forceinline constexpr T operator - (const T   lhs, const T   rhs) { return lhs - static_cast<int>(rhs); } \
    forceinline constexpr T operator * (const T   lhs, const int rhs) { return static_cast<T>(static_cast<int>(lhs) * rhs); } \
    forceinline constexpr T operator * (const int lhs, const T   rhs) { return rhs * lhs; } \
    forceinline constexpr T operator * (const T   lhs, const T   rhs) { return lhs * static_cast<int>(rhs); } \
    forceinline constexpr T operator / (const T   lhs, const int rhs) { return static_cast<T>(static_cast<int>(lhs) / rhs); } \
    forceinline constexpr T operator % (const int lhs, const T   rhs) { return static_cast<T>(lhs % static_cast<int>(rhs)); } \
    forceinline constexpr T operator % (const T   lhs, const T   rhs) { return static_cast<T>(static_cast<int>(lhs) % rhs); } \
    forceinline constexpr T operator - (const T   rhs) { return static_cast<T>(-static_cast<int>(rhs)); } \
    forceinline T operator ++ (T& lhs) { lhs += 1; return lhs; } /* Ou */    \
    forceinline T operator -- (T& lhs) { lhs -= 1; return lhs; } /* Ou */    \
    forceinline T operator ++ (T& lhs, int) { const T temp = lhs; lhs += 1; return temp; } /* u */ \
    /* forceinline T operator -- (T& lhs, int) { const T temp = lhs; lhs -= 1; return temp; } */ /* u */

using Ply = int;
constexpr Ply PlyOne = 1, MaxMove = 593, MaxPly = 128, MaxGamePly = 1024;

enum PieceType : uint8_t {
    King, Rook, Bishop, Gold, Silver, Knight, Lance, Pawn,
    HandTypeNum, Dragon, Horse, ProGold, ProSilver, ProKnight, ProLance, ProPawn,
    PieceTypeNum, PieceTypeNone = 0, Empty = HandTypeNum, Golds = Gold,
    DragonEx = ProGold, HorseEx, ProPawnEx,
};

enum Color : uint8_t {
    Black, White, ColorNum
};

enum Square : uint8_t {
    SQ_9A = 0,
    FileNum = 9, RankNum = 9, PromotionRank = 3, FileNumHalf = (FileNum + 1) / 2,
    SquareNum = FileNum * RankNum,
    PawnDrop = SquareNum + Pawn,
};
forceinline constexpr bool isNegative(Square sq) {
    return static_cast<std::make_signed<Square>::type>(sq) < 0;
}
//square(0, 0)͔Ղ̍\(Eł͂Ȃ) xsv
inline Square square(int x, int y) {
    return static_cast<Square>(x + y * FileNum);
}

enum Score : int32_t {
    ScoreZero,
    ScoreMate0Ply = INT16_MAX - INT16_MAX % 100,
    ScoreInfinite = ScoreMate0Ply + 3,
    ScoreMateInMaxPly = ScoreMate0Ply - MaxPly,
};
static_assert(ScoreInfinite < INT16_MAX, "");

enum Depth : int32_t {
    DepthZero, OnePly = 2,
    DepthQuiet = OnePly * 5,
    DepthMax = DepthQuiet + OnePly * static_cast<Depth>(MaxPly - 32),
    //DepthOneReply = DepthMax + 1,
};

OverloadEnumOperators(PieceType);
forceinline Color& operator++(Color &t) {
    return t = static_cast<Color>(t + 1);
}
forceinline constexpr Color OppositeColor(const Color c) {
    return static_cast<Color>(c ^ 1);
}
OverloadEnumOperators(Square);
OverloadEnumOperators(Score);
OverloadEnumOperators(Depth);

constexpr Square SquareSecond = static_cast<Square>(64);
constexpr int SlidingTypeNum = 4;
constexpr int SlidingStep[SlidingTypeNum] = { FileNum, 1, FileNum + 1, FileNum - 1 };//

class Bitboard {
    __m128i m128i_;
    
    struct Not {
        const __m128i not_m128i_;

        //~b1 & b2
        Bitboard operator&(const Bitboard& b) const {
            return Bitboard{ _mm_andnot_si128(not_m128i_, b.m128i_) };
        }
        //ʏnot
        operator Bitboard() const {
            __m128i temp;
            const __m128i mask = _mm_cmpeq_epi64(temp, temp);
            return Bitboard{ _mm_xor_si128(not_m128i_, mask) };
        }
        explicit Not(const Bitboard& b) : not_m128i_(b.m128i_) {}
    };

public:
    Bitboard::Not operator~() const {
        return Bitboard::Not{ *this };
    }
    //b1 &= ~b2
    Bitboard& operator&=(const Bitboard::Not& not_b) {
        m128i_ = _mm_andnot_si128(not_b.not_m128i_, m128i_);
        return *this;
    }
    Bitboard& operator&=(const Bitboard& b) {
        m128i_ = _mm_and_si128(m128i_, b.m128i_);
        return *this;
    }
    Bitboard& operator|=(const Bitboard& b) {
        m128i_ = _mm_or_si128(m128i_, b.m128i_);
        return *this;
    }
    Bitboard& operator^=(const Bitboard& b) {
        m128i_ = _mm_xor_si128(m128i_, b.m128i_);
        return *this;
    }
    //b1 & ~b2
    Bitboard operator&(const Bitboard::Not& not_b) const {
        return Bitboard{ _mm_andnot_si128(not_b.not_m128i_, m128i_) };
    }
    Bitboard operator&(const Bitboard& b) const {
        return Bitboard{ _mm_and_si128(m128i_, b.m128i_) };
    }
    Bitboard operator|(const Bitboard& b) const {
        return Bitboard{ _mm_or_si128(m128i_, b.m128i_) };
    }
    Bitboard operator^(const Bitboard& b) const {
        return Bitboard{ _mm_xor_si128(m128i_, b.m128i_) };
    }
    uint64_t b64(const int i) const {
        return m128i_.m128i_u64[i];
    }
    uint64_t popcnt() const {
        return __popcnt64(b64(0)) + __popcnt64(b64(1));
    }
    bool isNone() const {
        return _mm_testz_si128(m128i_, m128i_) != 0;
    }
    bool isSet(const Square sq) const {
        return (b64(sq / 64) & 1ULL << sq/* % 64*/) != 0;//sq64ȏł̂܂܂ł悢 ̃Vtg̃CeV2Œx %64ȂƖ`
    }
    std::string toString() const;

    //sqĂBitboardԂ
    explicit Bitboard(const Square sq);
    constexpr explicit Bitboard(const __m128i& b) : m128i_(b) {}
    Bitboard() {}
};

constexpr Bitboard ZeroBB{ __m128i{} };

struct Occupied {
    __m128i m128i_[SlidingTypeNum / 2];
    uint64_t b64(const int i) const {
        return m128i_[0].m128i_u64[i];
    }
};

forceinline Occupied &operator^=(Occupied& a1, const Occupied& a2) {
    a1.m128i_[0] = _mm_xor_si128(a1.m128i_[0], a2.m128i_[0]);
    a1.m128i_[1] = _mm_xor_si128(a1.m128i_[1], a2.m128i_[1]);
    return a1;
}
forceinline Occupied &operator|=(Occupied& a1, const Occupied& a2) {
    a1.m128i_[0] = _mm_or_si128(a1.m128i_[0], a2.m128i_[0]);
    a1.m128i_[1] = _mm_or_si128(a1.m128i_[1], a2.m128i_[1]);
    return a1;
}
forceinline Occupied operator^(const Occupied& a1, const Occupied& a2) {
    return{ _mm_xor_si128(a1.m128i_[0], a2.m128i_[0]) ,_mm_xor_si128(a1.m128i_[1], a2.m128i_[1]) };
}
forceinline Occupied operator|(const Occupied& a1, const Occupied& a2) {
    return{ _mm_or_si128(a1.m128i_[0], a2.m128i_[0]) ,_mm_or_si128(a1.m128i_[1], a2.m128i_[1]) };
}

constexpr Occupied ZeroOcc{};
static_assert((ZeroOcc.m128i_[0].m128i_u64[0] | ZeroOcc.m128i_[0].m128i_u64[1] | ZeroOcc.m128i_[1].m128i_u64[0] | ZeroOcc.m128i_[1].m128i_u64[1]) == 0, "");

//SquareBB[sq]sqڂĂ
extern Bitboard SquareBB[SquareNum];
//e̋ߐڗ ї̋ߐڗĂ ̗͋ɂ܂Ƃ߂
extern Bitboard StepAttacksBB[ColorNum][ProGold][SquareNum];

//ї SquareOccōXVOccupied::b64OccShiftVtgĉ7bitSlidingAttacksBB[sq]e[u
extern Bitboard SlidingAttacksBB[SquareNum][SlidingTypeNum + 2][1 << (FileNum - 2)];
extern Occupied SquareOcc[SquareNum];
extern uint8_t OccShift[SquareNum][SlidingTypeNum];

//2i 1̈ړpsqւ̗^ꏊ
extern Bitboard MoveTwiceBB[ColorNum][SquareNum][ProGold];
//psq̎8(ʂ̗)ւ̗ꏊ
extern Bitboard ToKingsubBB[ColorNum][SquareNum][ProPawnEx + 1];
//ʂ̓ꏊ256ʂɑ΂ċl܂Ƃłꏊ
//extern Bitboard MateCandidateBB[ColorNum][SquareNum][256][PieceTypeNum];

//InFrontBB[c][y]cɂƂĂ̓Gw琔yiڂ܂ŗĂ
extern Bitboard InFrontBB[ColorNum][RankNum + 1];
//pawnFileBB[̂]͕̑łĂꏊĂ
extern Bitboard PawnFileBB[1 << FileNum];
//FileBB[x]x؂Ă RankBB[y]yiڂĂ
extern Bitboard FileBB[FileNum], RankBB[RankNum];
extern Bitboard BetweenBB[SquareNum][SquareNum];//BetweenBB[s1][s2]͏s1s2̊Ԃɂ鏡Ă [͊܂܂Ȃ
extern int8_t Direction[SquareNum][SquareNum];//s1Direction[s1][s2]݂s2ɍs 0̂Ƃ͏c΂߂̈ʒu֌WɂȂ

void init_bitboards();

template <class T>
forceinline T add_if(const T a1, const bool condition, const T a2) {
    return condition ? a1 + a2 : a1;
}

//StruêƂfirst̑Oɔԕ(1vf)Kv
template <bool S = false, class I, class C = std::less<>>
forceinline void insertion_sort(I first, I last, C c = C{}) {
    for (I it = first; ++it < last;) {
        auto v0 = *(it - 1);
        const auto v1 = *it;
        if (c(v1, v0)) {
            I it_ = it;
            do {
                *it_-- = v0;
            } while ((S || it_ - 1 >= first) && (v0 = *(it_ - 1), c(v1, v0)));
            *it_ = v1;
        }
    }
}
