
#pragma once

#include <vector>

#include "bitboard.h"

using PIndex = int16_t;

constexpr int ListSize = 40, HandSize = ListSize - 2;

constexpr int FVScale = 32, ATScale = 32;

//[̔Տ̋][̎][BlackPEndIndex ̔Տ̋][̎]PEndIndex
constexpr PIndex BlackPEndIndex = (int)(ProGold - 1) * (int)SquareNum + HandSize;//ʂ܂
constexpr PIndex PEndIndex = BlackPEndIndex * 2;

constexpr int PPSize = PEndIndex * PEndIndex;
constexpr int AtNum = 9, AtEndIndex = 16 * AtNum, ATSize = AtEndIndex * AtEndIndex;

extern std::vector<int16_t> v_pp;
extern int16_t (*p_pp)[PEndIndex], *p_at;

//180x]
forceinline constexpr Square InverseSquare(const int sq) {
    return SquareNum - 1 - sq;
}
//E]
forceinline constexpr Square FlipSquare(const int sq) {
    return FileNum - 1 - sq % FileNum + sq - sq % FileNum;
}

constexpr int HandTable[HandTypeNum + 1] = { 0, 0, 2, 4, 8, 12, 16, 20, HandSize };

// n0ȏ n0̂Ƃ1ڂ̋
forceinline constexpr PIndex HandIndexSub(const PieceType p, const int n) {
    return HandTable[p] + n;
}
forceinline constexpr PIndex HandIndex(const Color c, const PieceType p, const int n) {
    return HandIndexSub(p, n) + BlackPEndIndex - HandSize + c * BlackPEndIndex;
}
forceinline constexpr PIndex HandIndex(const Color c, const PIndex pi) {
    return pi + BlackPEndIndex - HandSize + c * BlackPEndIndex;
}

PIndex PieceIndex2(const Color c, const PieceType p, const Square sq);

PIndex InverseIndex(const PIndex pi);
PIndex FlipIndex(const PIndex pi);
Square IndexToSquare(const PIndex pi);
PieceType IndexToPiece(const PIndex pi);

bool fv_is_ok();

struct Position;

template <Color C>
Score evaluate(Position& pos);

inline Score evaluate(const Color c, Position& pos) {
    return (c == Black) ? evaluate<Black>(pos) : evaluate<White>(pos);
}
