
#include "move.h"
#include "usi.h"

std::string Move::toUSI() const {
    if (value_ == NoneValue) return "resign";

    std::string s;
    auto add = [&](int sq) {
        s += '1' + FileNum - 1 - sq % FileNum;
        s += 'a' + sq / FileNum;
    };

    if (from() < SquareNum) {
        add(from());
        add(to());
        if (promote()) s += '+';
    } else {
        s += sfenPiece[piece()];
        s += '*';
        add(to());
    }
    return s;
}
