
#pragma once

#include "bitboard.h"
#include "position.h"
#include "move.h"

enum GenerateMovePhase {
    MainSearch, PH_TacticalMoves0, PH_Killers, PH_NonTacticalMoves0, PH_NonTacticalMoves1, PH_BadCaptures, PH_Stop1,
    EvasionSearch, PH_Evasions0, PH_Evasions1, PH_Stop2,
    QSearch, PH_QCaptures0, PH_Stop3,
    /*QRecapture, */PH_QCaptures1, PH_Stop4,
    ProbCut, PH_TacticalMoves1, PH_Stop5,
};
OverloadEnumOperators(GenerateMovePhase);

template <Color C, bool SC = true>
Move *generate_captures(Move *moves, const Position& pos);
template <Color C>
Move *generate_non_captures(Move *moves, const Position& pos);
template <Color C>
Move *generate_drops(Move *moves, const Position& pos);
template <Color C>
Move *generate_recaptures(Move *moves, const Position& pos);
template <Color C>
Move *generate_non_evasions(Move *moves, const Position& pos);
template <Color C>
Move *generate_non_evasions_ex(Move *moves, const Position& pos);
template <Color C>
Move *generate_evasions_base(Move *moves, const Position& pos);
template <Color C>
Move *generate_evasions_interpose(Move *moves, const Position& pos);
template <Color C>
Move *generate_evasions(Move *moves, const Position& pos);
template <Color C>
Move *generate_evasions_ex(Move *moves, const Position& pos);
template <Color C>
Move *generate_pseudo_legal(Move *moves, const Position& pos);
Move * generate_pseudo_legal(Move * moves, const Color c, const Position & pos);
