
#include <random>

#include "position.h"
#include "thread.h"
#include "movegen.h"
#include "tt.h"
#include "evaluate.h"
#include "usi.h"

//s{ӂǂăRpC萔ɂ
#define P (o.value)

//template <size_t N, class F>
//auto GetScoreArray(F f) {
//    constexpr int piece_score[PieceTypeNum] = {
//        0, 800, 700, 500, 400, 300, 300, 100,
//        0, 900, 800,   0, 500, 500, 500, 500, };
//    std::ifstream ifs{ "material.txt", std::ios::in };
//
//    std::array<Score, N> a;
//    for (int i = 0; i < N; ++i) {
//        int s = piece_score[i];
//        if (ifs.is_open() && !ifs.eof()) ifs >> s;
//        a[i] = f(i, s);
//    }
//    return a;
//}

//wKŏ邽constłȂ
Score PieceScore[PieceTypeNum];
Score CapturePieceScore[PieceTypeNum];
Score PromotePieceScore[HandTypeNum];

void init_piece_score(const bool use_file) {
    if (use_file) {
        constexpr int piece_score[PieceTypeNum] = {
            0, 800, 700, 500, 400, 300, 300, 100,
            0, 900, 800,   0, 500, 500, 500, 500, };
        std::string path = "material.txt";
        std::ifstream ifs{ path, std::ios::in };
        if (!ifs.is_open()) std::cout << "info string " << path << " not found." << std::endl;
        for (int i = 0; i < PieceTypeNum; ++i) {
            int s = piece_score[i];
            if (ifs.is_open() && !ifs.eof()) ifs >> s;

            PieceScore[i] = static_cast<Score>(s);
        }
    }
    for (int i = 0; i < PieceTypeNum; ++i) {
        CapturePieceScore[i] = PieceScore[i] + PieceScore[i % HandTypeNum];
    }
    for (int i = 0; i < HandTypeNum; ++i) {
        PromotePieceScore[i] = PieceScore[i + HandTypeNum] - PieceScore[i];
    }
}

uint64_t Position::zobrist_[ColorNum][PieceTypeNum][SquareNum];

void Position::initZobrist() {
    std::mt19937_64 mt;
    for (int i = 0; i < sizeof zobrist_ / sizeof ***zobrist_; ++i) {
        zobrist_[0][0][i] = mt();
    }
}

template <Color C>
forceinline Square Position::pinCheck(const Square from, const Square to, const Square target, const Occupied occupied) const {
    const Square king = target;
    if (Direction[king][from] != 0 && Direction[king][from] != Direction[king][to] && (BetweenBB[king][from] & ~byTypeBB_[Empty]).isNone()) {
        const int step = abs(Direction[king][from]);
        const int j = (step == SlidingStep[0]) ? 0 : (step == SlidingStep[1]) ? 1 : (step == SlidingStep[2]) ? 2 : 3;
        Bitboard b = sliding_attacks_bb(from, j, occupied) & byColorBB_[C] & ~SquareBB[king];
#ifdef DEBUG
        if (b.popcnt() > 1) {
            std::cout << toKifu() << " : " << king << " " << from << " " << to << " " << previous_move_.toUSI() << std::endl;
            for_each_bb(b, [&](const Square sq) {
                std::cout << sq << std::endl;
            });
            assert(0);
        }
#endif
        if (!b.isNone()) {
            Square pinner;//1ĂƂ킩Ă
            any_of_bb(b, [&](const Square sq) {
                pinner = sq;
                return true;
            });
            if (j < 2) {
                if (piece_[pinner] % HandTypeNum == Rook) return pinner;
                if (j == 0 && piece_[pinner] == Lance && ColorToSign(C) * static_cast<std::make_signed<Square>::type>(pinner - from) > 0) return pinner;
            } else {
                if (piece_[pinner] % HandTypeNum == Bishop) return pinner;
            }
        }
    }
    return static_cast<Square>(-1);
}
template Square Position::pinCheck<Black>(const Square from, const Square to, const Square target, const Occupied occupied) const;
template Square Position::pinCheck<White>(const Square from, const Square to, const Square target, const Occupied occupied) const;

template<Color C>
Square Position::pinCheck(const Square from, const Square to) const {
    return pinCheck<C>(from, to, king_[OppositeColor(C)], occupied_);
}

//toֈړĂpinOȂʕAttacker邩 ԗl܂ ړ̏ꍇ͗(AttackertoȂ)ׂ
template <Color C, bool Drop>
forceinline bool notPinnedAttackersTo(Position& pos, const Square from, const Square to, const Occupied& occupied) {
    const Bitboard pinnedBB = pos.attackersTo<OppositeColor(C), true>(to, occupied);
    const uint64_t n = pinnedBB.popcnt();
    if (n == 0) return false;
    if (!Drop && !isNegative(pos.pinCheck<C>(from, to))) return false;//͊Jł܂藼肾
    if (n > 1) return true;

    Square pinned_from;
    any_of_bb(pinnedBB, [&](const Square pinned) {
        pinned_from = pinned;
        return true;
    });
    if (!Drop) { pos.byColorBB_[C] ^= SquareBB[from]; pos.byTypeBB_[Empty] ^= SquareBB[from]; }
    const Square pinner = pos.pinCheck<C>(pinned_from, to);
    if (!Drop) { pos.byColorBB_[C] ^= SquareBB[from]; pos.byTypeBB_[Empty] ^= SquareBB[from]; }
    return isNegative(pinner);
};

//C̔p邱Ƃősq()ւ̗A炷
template <Color C, bool A>
forceinline void exAttackers(Position& pos, const Square sq, const Bitboard kingMoveBB = ZeroBB) {
    Bitboard b = ZeroBB;
    auto f = [&](auto o) {
        Bitboard fromBB = pos.byTypeBB_[P];
        if (A) {
            //ŏ瑼̗̋ŋʂȂP[XƂ̂ŁA܂ʂɑ
            fromBB &= ToKingsubBB[C][sq][(P == Dragon) ? DragonEx : (P == Horse) ? HorseEx : ProPawnEx];
        } else {
            fromBB &= step_attacks_bb(OppositeColor(C), P, sq);
            //̉Ŏ邱Ƃ͂łȂ
            if (P != Golds) fromBB &= ~step_attacks_bb(OppositeColor(C), P % HandTypeNum, sq);
        }
        if (P == Golds) {
            //ρAƋBitboardĂȂƕsւ
            for_each_bb(fromBB & pos.byColorBB_[C], [&](const Square from) {
                if (pos.piece_[from] == ProPawn) b ^= SquareBB[from];
            });
        } else {
            b ^= fromBB;
        }
    };
    f(NPieceType<Dragon>{});
    f(NPieceType<Horse>{});
    f(NPieceType<Golds>{});
    b &= pos.byColorBB_[C];
    if (!A && b.popcnt() != 1) return;
    if (A && b.isNone()) return;

    for_each_bb(b, [&](const Square from) {
        const PieceType piece = pos.piece_[from];
        assert(piece == Dragon || piece == Horse || piece == ProPawn);
        bool cond;
        pos.byColorBB_[C] ^= SquareBB[from];
        if (A) {
            cond = canKingEscape<C>(pos, kingMoveBB & ~attacks_bb(C, from, piece % HandTypeNum, pos.occupied_), pos.occupied_);
        } else {
            cond = pos.attackersTo<C, true>(sq, pos.occupied_).isNone();//sq͕łꏊ
            assert(!step_attacks_bb(C, piece % HandTypeNum, from).isSet(sq));
        }
        pos.byColorBB_[C] ^= SquareBB[from];
        if (!cond) b ^= SquareBB[from];
    });

    //std::cout << "info string " << b.popcnt() << " " << pos.toKifu() << std::endl;
    //if (b.popcnt() > 1) {
    //    return;
    //}

    for (int i = A; i < pos.ply_; i += 2) {
        Move move = pos.forward(-i).previous_move_;
        if (b.isSet(move.to())) {
            assert(!move.isDrop());
            if (move.isPromotion()) {
                pos.forward(-i - 1).ex_move_ = move.togglePromotion();
                break;
            }
            b ^= SquareBB[move.to()] ^ SquareBB[move.from()];
        }
    }
}

template <Color C>
bool Position::isWin() {
    assert(!checked_);
    if (!PromotionZone(C, king_[C])) return false;

    const Bitboard b = byColorBB_[C] & InFrontBB[C][PromotionRank];
    const uint64_t n = b.popcnt();
    if (n <= 10) return false;//ʂ܂񂾐10ł͑Ȃ

    const Bitboard heavyBB = b & (byTypeBB_[Rook] | byTypeBB_[Bishop] | byTypeBB_[Dragon] | byTypeBB_[Horse]);
    const uint64_t heavy_hand_num = hand_[C][Rook] + hand_[C][Bishop];
    const uint64_t hand_num = heavy_hand_num + hand_[C][Gold] + hand_[C][Silver] + hand_[C][Knight] + hand_[C][Lance] + hand_[C][Pawn];

    constexpr uint64_t Threshold = ((C == Black) ? 28 : 27) + 1;//Gwɂʂ̂Ԃ+1
    const uint64_t value = n + hand_num + (5 - 1) * (heavyBB.popcnt() + heavy_hand_num);

    return value >= Threshold;
}
template bool Position::isWin<Black>();
template bool Position::isWin<White>();

template <Color C>
bool Position::isMateIn1Ply() {
    //ߐډłړɎ̗葊̗ʂȂƂ̂ jnԗȂǂ̗O
    assert(!checked_);

    //ʂ̈ʒu
    const Square king = king_[OppositeColor(C)];

    Bitboard slidingAttacksBB = ZeroBB;
    //̗ ʂ̎8̂
    const Bitboard kingsubAttacksBB = [&]() {
        Bitboard b = ZeroBB;
        for_each_piece([&](auto o) {
            Bitboard fromBB = byTypeBB_[P] & byColorBB_[C] & ToKingsubBB[C][king][P];
            if (fromBB.isNone()) return;
            for_each_bb(fromBB, [&](const Square from) {
                b |= attacks_bb(C, from, P, occupied_);
                if (P % HandTypeNum == Rook || P % HandTypeNum == Bishop || P == Lance) slidingAttacksBB |= sliding_attacks_to_edge_bb(C, from, P);
            });
        });
        return b;
    }();

    //ʂ̉͈ ʎĝꏊĂ邪ÂŖȂ Rt܂͌j̉ĂAȊȌꏊւ͓Ȃ
    const Bitboard kingAttacksBB = attacks_bb(OppositeColor(C), king, King, occupied_);
    const Bitboard kingMoveBB = kingAttacksBB & ~byColorBB_[OppositeColor(C)];
    const Bitboard kingMoveCurrBB = kingMoveBB & ~kingsubAttacksBB;//͖ڈƂĎg

    //eȂʂ̎9ɗ^闘̍ő吔 J邯
    constexpr int AttackCntSup[PieceTypeNum] = {
        0, 4, 2, 5, 3, 1, 2, 1,
        0, 6, 5, 0, 5, 5, 5, 5, };
    const uint64_t escapeCnt = kingMoveCurrBB.popcnt() + 1;//+1͋ʂ鏡
    assert(escapeCnt > 0);
    if (escapeCnt > 6) return false;
    if (escapeCnt > 1 && (kingsubAttacksBB & kingAttacksBB).isNone()) return false;//݂邵jl

    //l܂ƂɎgp Ԃŉ肵ʂĂłȂ
    const Occupied occupied = occupied_ ^ SquareOcc[king];

    //ł
    const Bitboard dropKnightToBB = byTypeBB_[Empty];
    const Bitboard dropToBB = dropKnightToBB & kingsubAttacksBB;

    bool drop_mate = any_of_piece<true>([&](auto o) {
        if (/*P == Pawn || */P >= HandTypeNum) return false;
        if (hand_[C][P] == 0) return false;
        if (AttackCntSup[P] < escapeCnt) return false;

        //łl falseԂ
        if (P == Pawn) {
            const Square to = king + FileNum * ColorToSign(C);
            if (!dropToBB.isSet(to)) return false;

            //
            if (!(byTypeBB_[Pawn] & byColorBB_[C] & FileBB[to % FileNum]).isNone()) return false;

            //łɎ̔їĂȂΎ̗邱Ƃ͂Ȃ
            if (slidingAttacksBB.isSet(to)) {
                //ʂ𓦂肪邩
                const Occupied occupied_next = occupied ^ SquareOcc[to];//ʂł
                if (canKingEscape<C>(*this, kingMoveBB & ~SquareBB[to], occupied_next)) return false;
            }

            if (!notPinnedAttackersTo<C, true>(*this, SQ_9A, to, occupied_)) {
                //łl߂ÂƂpsɂĂΑłl܂Ȃ
                exAttackers<C, true>(*this, king, kingMoveBB);
            } else {
                //łl߂ł͂ȂÂƂ肪psɂĂΑłl߂ɂȂĂ
                exAttackers<OppositeColor(C), false>(*this, to);
            }
            return false;
        }

        const Bitboard toBB = ((P == Knight) ? dropKnightToBB : dropToBB) & step_attacks_bb(OppositeColor(C), P, king);
        if (toBB.isNone()) return false;

        return any_of_bb(toBB, [&](const Square to) {
            const Bitboard attacksBB = attacks_bb(C, to, P, occupied);
            if (!(kingMoveCurrBB & ~attacksBB).isNone()) return false;

            if (notPinnedAttackersTo<C, true>(*this, SQ_9A, to, occupied_)) return false;

            //łɎ̔їĂȂΎ̗邱Ƃ͂Ȃ
            if (P != Knight && !slidingAttacksBB.isSet(to)) return true;

            //ʂ𓦂肪邩
            const Occupied occupied_next = occupied ^ SquareOcc[to];//ʂł
            return !canKingEscape<C>(*this, kingMoveBB & ~attacksBB & ~SquareBB[to], occupied_next);
        });
    });
    if (drop_mate) return true;

    //ړ P͈ړŐ
    const Bitboard kingMoveCurrExBB = kingMoveCurrBB & ~slidingAttacksBB;//炷Ԃɂ͒xȂ邾ŋl݂𓦂Ȃ悤ɂȂ
    bool move_mate = any_of_piece<true>([&](auto o) {
        if (AttackCntSup[P] < escapeCnt && (!CanPromote(P) || AttackCntSup[P + HandTypeNum] < escapeCnt)) return false;

        Bitboard fromBB = byTypeBB_[P] & byColorBB_[C] & MoveTwiceBB[C][king][P];
        if (fromBB.isNone()) return false;

        return any_of_promotion([&](auto oo) {
            constexpr bool Promotion = (oo.value == HandTypeNum);
            if (Promotion && !CanPromote(P)) return false;
            if ((P == Rook || P == Bishop || P == Pawn) && !Promotion) fromBB &= InFrontBB[OppositeColor(C)][RankNum - PromotionRank];//s͌ゾύXł

            return any_of_bb(fromBB, [&](const Square from) {
                constexpr bool Promotion = (oo.value == HandTypeNum);
                constexpr PieceType PTo = CvtIfGolds(P + oo.value);

                Bitboard toBB = ~byColorBB_[C] & attacks_bb(C, from, P, occupied_) & step_attacks_bb(OppositeColor(C), PTo, king);
                if (Promotion && !PromotionZone(C, from)) toBB &= InFrontBB[C][PromotionRank];
                if ((P == Rook || P == Bishop || P == Pawn) && !Promotion) toBB &= InFrontBB[OppositeColor(C)][RankNum - PromotionRank];
                if (P == Silver && !Promotion) toBB &= InFrontBB[C][king / FileNum] | InFrontBB[OppositeColor(C)][RankNum - PromotionRank];
                if (toBB.isNone()) return false;

                byTypeBB_[P] ^= SquareBB[from];

                bool mate = any_of_bb(toBB, [&](const Square to) {
                    constexpr PieceType PTo = CvtIfGolds(P + oo.value);//2񏑂̂͌ǎdȂ P̓}NgĂ

                    const Bitboard attacksBB = attacks_bb(C, to, PTo, occupied);
                    if (!(kingMoveCurrExBB & ~attacksBB).isNone()) return false;

                    const Occupied occupied_next = (occupied ^ SquareOcc[from]) | SquareOcc[to];//Ȃ̂xorł͂Ȃor
                    //肵̗̋ȂʂŎԂċl܂Ȃ canKingEscapeł͈ړO̗Kv
                    if (PTo != Knight && attackersTo<C>(to, occupied_next).isNone()) return false;

                    //ʂ̗̋l܂Ȃ occupied_nextgƋʂ蔲ĎɗĂ邱Ƃ邩
                    if (notPinnedAttackersTo<C, false>(*this, from, to, occupied_ ^ SquareOcc[from])) return false;

                    //ʂ𓦂肪邩 ƂĂȀꏊւC̗
                    if (canKingEscape<C>(*this, kingMoveBB & ~attacksBB & ~SquareBB[to], occupied_next)) return false;

                    return isNegative(pinCheck<OppositeColor(C)>(from, to));
                });

                byTypeBB_[P] ^= SquareBB[from];

                return mate;
            });
        });
    });
    return move_mate;
}
template bool Position::isMateIn1Ply<Black>();
template bool Position::isMateIn1Ply<White>();

#ifdef MATE_TEST
//1l߂ǂ𐳊mɔ肷
template <Color C>
bool Position::isMateIn1Ply_Slow() {
    bool mate = false;
    Move moves[MaxMove];
    const Move *last = generate_non_evasions<C>(moves, *this);
    for (Move *current = moves; current != last; ++current) {
        Move move = *current;
        if (move.from() == PawnDrop) continue;
        if (!moveGivesCheck<C>(move)) continue;
        if (!pseudoLegalMoveIsLegal<C>(move)) continue;
        doMove(C, move);
        Position& pos = this->next();
        {
            Move moves[MaxMove];
            const Move *last = generate_evasions<OppositeColor(C)>(moves, pos);
            for (Move *current = moves; current != last || (mate = true, false); ++current) {
                Move move = *current;
                if (pos.pseudoLegalMoveIsLegal<OppositeColor(C)>(move)) break;
            }
        }
    }
    return mate;
}
template bool Position::isMateIn1Ply_Slow<Black>();
template bool Position::isMateIn1Ply_Slow<White>();
#endif

template <Color C>
bool Position::pseudoLegalMoveIsLegal(const Move move) const {
    const Square from = move.from();
    if (from < SquareNum) {
        const Square to = move.to();
        if (move.piece() == King) {
            if (!attackersTo<OppositeColor(C)>(to, occupied_ ^ SquareOcc[from]).isNone()) return false;
        } else {
            if (!isNegative(pinCheck<OppositeColor(C)>(from, to))) return false;
        }
    }
    return true;
}
template bool Position::pseudoLegalMoveIsLegal<Black>(const Move move) const;
template bool Position::pseudoLegalMoveIsLegal<White>(const Move move) const;

template <Color C>
bool Position::moveGivesCheck(const Move move) {
    const Square to = move.to();
    const Square from = move.from();
    const Square king = king_[OppositeColor(C)];
    const PieceType pieceTo = add_if(move.piece(), move.isPromotion(), HandTypeNum);
    Position& pos = next();

    //ډ fromɎՂĉɂȂȂȂĂƂ͂Ȃ
    pos.checkerAttacksBB_ = attacks_bb(C, to, CvtIfGolds(pieceTo), occupied_ ^ SquareOcc[king]);
    pos.checked_ = pos.checkerAttacksBB_.isSet(king);//ډ
    if (pos.checked_) pos.checker_ = to;//łȂƂ͉ĂĂ

    //J
    if (from < SquareNum) {
        Square pinner = pinCheck<C>(from, to);
        if (!isNegative(pinner)) {
            if (!pos.checked_) pos.checker_ = pinner;
            ++pos.checked_;
            assert(piece_[pinner] % HandTypeNum == Rook || piece_[pinner] % HandTypeNum == Bishop || piece_[pinner] == Lance);
            pos.checkerAttacksBB_ |= sliding_attacks_to_edge_bb(C, pinner, piece_[pinner]);//attacks_bb(C, pinner, piece_[pinner], occupied_ ^ SquareOcc[king]);
        }
    }

    return pos.checked_ != 0;
}
template bool Position::moveGivesCheck<Black>(const Move move);
template bool Position::moveGivesCheck<White>(const Move move);

template <Color C>
void Position::doMoveSub(const Move move) {
    const Square to = move.to();
    const Square from = move.from();

    if (from < SquareNum) {
        //ړ
        const PieceType cap = move.cap();
#ifdef DEBUG
        assert(!move.isNone());
        if (cap != piece_[to]) std::cout << cap << " " << piece_[to] << " " << forward(-1).toKifu() << " " << move.toUSI() << std::endl;
        assert(cap == piece_[to]);
#endif
        if (cap) {
            //
            occupied_ ^= SquareOcc[from];
            byTypeBB_[Empty] ^= SquareBB[from];
            byColorBB_[OppositeColor(C)] ^= SquareBB[to];
            byTypeBB_[CvtIfGolds(cap)] ^= SquareBB[to];

            static_eval_raw_[2] += CapturePieceScore[cap] * ColorToSign(C);
            ++hand_[C][cap % HandTypeNum];
            board_key_ ^= zobrist_[OppositeColor(C)][cap][to];

        } else {
            occupied_ ^= SquareOcc[from];
            occupied_ ^= SquareOcc[to];
            byTypeBB_[Empty] ^= SquareBB[from] | SquareBB[to];
        }

        const Bitboard fromToBB = SquareBB[from] | SquareBB[to];
        const PieceType piece = move.piece();

        if (move.promote()) {
            const PieceType pieceTo = piece + HandTypeNum;
            byColorBB_[C] ^= fromToBB;
            byTypeBB_[piece] ^= SquareBB[from];
            byTypeBB_[CvtIfGolds(pieceTo)] ^= SquareBB[to];

            static_eval_raw_[2] += PromotePieceScore[piece] * ColorToSign(C);
            board_key_ ^= zobrist_[C][piece][from] ^ zobrist_[C][pieceTo][to];

            piece_[to] = pieceTo;

        } else {
            byColorBB_[C] ^= fromToBB;
            byTypeBB_[CvtIfGolds(piece)] ^= fromToBB;

            board_key_ ^= zobrist_[C][piece][from] ^ zobrist_[C][piece][to];

            if (piece == King) king_[C] = to;
            piece_[to] = piece;
        }
        piece_[from] = PieceTypeNone;

    } else {
        //ł
        const PieceType piece = static_cast<PieceType>(from - SquareNum);
        occupied_ ^= SquareOcc[to];
        byTypeBB_[Empty] ^= SquareBB[to];
        byColorBB_[C] ^= SquareBB[to];
        byTypeBB_[CvtIfGolds(piece)] ^= SquareBB[to];

        --hand_[C][piece];
        board_key_ ^= zobrist_[C][piece][to];

        piece_[to] = piece;
    }

    //vtFb`
    key_ = key(OppositeColor(C));//i߂̂ŎԂςĂ
    tt.prefetch(key_);

    ++ply_;

    if (checked_) {
        continuous_check_[C] += ColorNum;
    } else {
        continuous_check_[C] = 0;
    }

    previous_move_ = move;

    static_eval_ = ScoreInfinite;//ʂ̋ǖʂ̕]l𖳌ɂ
}
template void Position::doMoveSub<Black>(const Move move);
template void Position::doMoveSub<White>(const Move move);

template <Color C>
void Position::doNullMoveSub() {
    key_ = key(OppositeColor(C));
    tt.prefetch(key_);

    next().previous_move_ = previous_move_ = Move::None();
    ++ply_;

    continuous_check_[C] = 0;

    checkerAttacksBB_ = ZeroBB;
    assert(excluded_move_.isNone());
    checked_ = 0;
    skip_nullmove_ = 1;
    assert(reduction_ == 0);
    static_eval_ = ScoreInfinite;
}
template void Position::doNullMoveSub<Black>();
template void Position::doNullMoveSub<White>();

void Position::undoMove(const Color c, const Move move) {
    const Square to = move.to();
    const Square from = move.from();

    if (from < SquareNum) {
        //ړ
        if (move.cap()) {
            //
            byColorBB_[OppositeColor(c)] ^= SquareBB[to];
            --hand_[c][move.cap() % HandTypeNum];
        }

        byColorBB_[c] ^= SquareBB[from] | SquareBB[to];
        piece_[to] = move.cap();
        piece_[from] = move.piece();
        if (move.piece() == King) king_[c] = from;

    } else {
        //ł
        const PieceType piece = static_cast<PieceType>(from - SquareNum);
        byColorBB_[c] ^= SquareBB[to];
        piece_[to] = PieceTypeNone;
        ++hand_[c][piece];
    }

    Position pos = *this;
    clear();
    std::memcpy(byColorBB_, pos.byColorBB_, sizeof byColorBB_);
    std::memcpy(piece_, pos.piece_, sizeof piece_);
    std::memcpy(hand_, pos.hand_, sizeof hand_);
    root_turn_ = c;
    normalize();
    pos.key_ = pos.key(c);

    ply_ = 0;
    previous_move_ = Move::None();
}

void Position::clear() {
    std::memset(this, 0, sizeof *this);
    hand_[White][King] = ZobristColor;
    byTypeBB_[Empty] = InFrontBB[Black][RankNum];//S𖄂߂
    this_thread_ = &threads[0];
}

void Position::normalize() {
    for (Color c = Black; c < ColorNum; ++c) {
        for_each_bb(byColorBB_[c], [&](const Square sq) {
            PieceType p = piece_[sq];
            occupied_ ^= SquareOcc[sq];
            byTypeBB_[Empty] ^= SquareBB[sq];
            byTypeBB_[CvtIfGolds(p)] ^= SquareBB[sq];
            board_key_ ^= zobrist_[c][p][sq];
            if (p == King) king_[c] = sq;
        });
    }

    key_ = key(root_turn_);
    static_eval_ = evaluate<ColorNum>(*this) * ColorToSign(root_turn_);

    Bitboard checkersBB = (root_turn_ == Black) ? attackersTo<White>(king_[Black], occupied_) : attackersTo<Black>(king_[White], occupied_);
    checked_ = static_cast<uint8_t>(checkersBB.popcnt());
    for_each_bb(checkersBB, [&](const Square sq) {
        checker_ = sq;
    });
    continuous_check_[OppositeColor(root_turn_)] = checked_ ? 1 : 0;
}

std::string Position::toUSI() const {
    std::string s = "sfen ";

    PieceType pt[SquareNum] = {};
    for (Color c = Black; c < ColorNum; ++c) {
        for_each_bb(byColorBB_[c], [&](const Square sq) {
            pt[sq] = piece_[sq] + ((c + 1) << 4);
        });
    }

    for (int y = 0; y < RankNum; ++y) {
        if (y > 0) s += '/';
        int n = 0;
        for (int x = 0; x < FileNum; ++x) {
            Square sq = square(x, y);
            if (pt[sq] == 0) {
                n++;
            } else {
                if (n > 0) {
                    s += std::to_string(n);
                    n = 0;
                }
                if (pt[sq] & HandTypeNum) s += '+';
                s += sfenPiece[pt[sq] % HandTypeNum + (pt[sq] >> 5) * HandTypeNum];
            }
        }
        if (n > 0) s += std::to_string(n);
    }
    s += ' ';
    s += ((root_turn_ + ply_ & 1) == 0) ? 'b' : 'w';
    s += ' ';
    int handNum = 0;
    for (Color c = Black; c < ColorNum; ++c) {
        for (PieceType p = Rook; p < HandTypeNum; p++) {
            int n = hand_[c][p];
            handNum += n;
            if (n == 0) continue;
            if (n > 1) s += std::to_string(n);
            s += sfenPiece[p + static_cast<int>(c) * HandTypeNum];
        }
    }
    if (handNum == 0) s += '-';
    s += " 1";
    return s;
}

std::string Position::toKifu() const {
    Ply ply = static_cast<Ply>(ply_);
    if (ply == 0) return toUSI();

    std::string s = forward(-ply).toUSI() + " moves";
    for (int i = ply - 1; i >= 0; --i) {
        s += ' ' + forward(-i).previous_move_.toUSI();
    }
    return s;
}
