
#pragma once

#include <fstream>
#include <algorithm>
#include <array>

#include "bitboard.h"
#include "move.h"
#include "evaluate.h"

extern Score PieceScore[PieceTypeNum];
extern Score CapturePieceScore[PieceTypeNum];
extern Score PromotePieceScore[HandTypeNum];

void init_piece_score(const bool use_file = true);

class Thread;

struct PositionMin {
    Occupied occupied_;
    Bitboard byColorBB_[ColorNum];
    Bitboard byTypeBB_[ProGold];

    union {
        uint64_t hand64_[ColorNum];
        uint8_t hand_[ColorNum][HandTypeNum];
    };
    uint64_t board_key_;//Ֆʂ̃nbVL[(ԂƎ͊܂܂Ȃ)

    Square king_[ColorNum];//ʂ̈ʒu
    uint8_t continuous_check_[ColorNum];//݂̘A萔

    int32_t static_eval_raw_[3];//肩猩]l32{

    uint8_t ply_;//Root̎萔
    PieceType piece_[SquareNum];//݂΂̋A݂ȂPieceTypeNone(KingƓlȂ̂Œ)

    PIndex list_[ListSize];//Xg ʂ܂40
    uint8_t hand_to_list_index_[ColorNum][HandSize];
    uint8_t square_to_list_index_[SquareNum];//sqɋ΂̋PIndexlist_[square_to_list_index_[sq]]Ɋi[Ă

    //1byte̋󂫂̂ł邩
    Color root_turn_;//Root̎

    //͂ݏoĂ܂ ߂Stack邩[
    Thread *this_thread_;
};

//ǖ
struct alignas(64) Position : public PositionMin {
    static constexpr uint64_t ZobristColor = 1ULL << 5, ZobristExclusion = 1ULL << 6;//ƔȂꏊɂ
    static uint64_t zobrist_[ColorNum][PieceTypeNum][SquareNum];
    static void Position::initZobrist();

    //Őǖʂ̏g킸ɍXV YꂪȂ悤
    Bitboard checkerAttacksBB_;//̗̈ꕔ(ʂ𓧉߂) [ł삷
    uint64_t key_;//ǖʂ̃nbVL[
    Move previous_move_;//wč̋ǖʂɂȂ
    Move excluded_move_;
    Move killer_move_[2];
    Move ex_move_;
    Score static_eval_;//Ԃ猩]l
    uint8_t checked_;//Ԃ̋ʂɉ肪Ă邩 ۂɂ͉肵Ă̐ė蔻ɂg
    Square checker_;//肪ĂƂA肵Ă̈
    int16_t reduction_;
    uint8_t skip_nullmove_;
    uint8_t maybe_in_tsumero_;//1ȏ̎qm[hԂ̂ŋl߂납Ȃ

    //ǖʂ̃nbVL[ C萔ɂ邽߂forceinlineH
    forceinline uint64_t key(Color C) const {
        return board_key_ + hand64_[C];//hand64_m̍m肽瑫Z(xorm肽Ȃxor)
    }

    //1i񂾋ǖ \doMoveōĂKv
    Position& next() {
        return this[1];
    }
    Position& forward(int i) {
        return this[i];
    }
    const Position& forward(int i) const {
        return this[i];
    }

    //sqւ̗C̋
    template <Color C, bool ExceptKing = false>
    Bitboard attackersTo(Square sq, const Occupied& occupied) const {
        return byColorBB_[C] & (
            (attacks_bb(OppositeColor(C), sq, Rook, occupied) & (byTypeBB_[Rook] | byTypeBB_[Dragon])) |
            (attacks_bb(OppositeColor(C), sq, Bishop, occupied) & (byTypeBB_[Bishop] | byTypeBB_[Horse])) |
            (attacks_bb(OppositeColor(C), sq, Knight, occupied) & byTypeBB_[Knight]) |
            (attacks_bb(OppositeColor(C), sq, Lance, occupied) & byTypeBB_[Lance]) |
            (attacks_bb(OppositeColor(C), sq, Pawn, occupied) & byTypeBB_[Pawn]) |
            (ExceptKing ?
             (attacks_bb(OppositeColor(C), sq, Golds, occupied) & (byTypeBB_[Golds] | byTypeBB_[Horse])) |
             (attacks_bb(OppositeColor(C), sq, Silver, occupied) & (byTypeBB_[Silver] | byTypeBB_[Dragon]))
             :
             (attacks_bb(OppositeColor(C), sq, King, occupied) & (byTypeBB_[King] | byTypeBB_[Dragon] | byTypeBB_[Horse])) |
             (attacks_bb(OppositeColor(C), sq, Golds, occupied) & byTypeBB_[Golds]) |
             (attacks_bb(OppositeColor(C), sq, Silver, occupied) & byTypeBB_[Silver])
             ));
    }

    //Cpinner̎ targetɂfrom̋pinĂ̏(Ȃ-1)Ԃ from͔ՏɂȂ΂ȂȂ
    template <Color C>
    Square pinCheck(const Square from, const Square to, const Square target, const Occupied occupied) const;
    template <Color C>
    Square pinCheck(const Square from, const Square to) const;

    //Ԃ錾ł邩
    template<Color C>
    bool isWin();
    //1l 肪ĂƂɌĂł͂Ȃ
    template <Color C>
    bool isMateIn1Ply();
    template<Color C>
    bool isMateIn1Ply_Slow();

    //SEEthresholdȏォǂ킩琳mȒl͋߂Ȃ
    template <Color C>
    Score see(const Move move, const int threshold) const;
    //thresholdȏȂtrueԂ
    template <Color C>
    bool seeSign(const Move move, const int threshold) const;

    //move͏Ō悤Ȏ肾Ƃ
    template <Color C>
    bool moveIsPseudoLegal(const Move move) const;
    bool moveIsPseudoLegal(const Color c, const Move move) const {
        return (c == Black) ? moveIsPseudoLegal<Black>(move) : moveIsPseudoLegal<White>(move);
    }

    //uĂȂ
    template <Color C>
    bool pseudoLegalMoveIsLegal(const Move move) const;
    //肩 next()checkerAttacksBB_, checked_, checker_ŃZbg
    template <Color C>
    bool moveGivesCheck(const Move move);
    //i߂
    template <Color C>
    void doMoveSub(const Move move);
    forceinline void doMove(const Color c, const Move move) {
        *static_cast<PositionMin *>(&next()) = *this;
        (c == Black) ? next().doMoveSub<Black>(move) : next().doMoveSub<White>(move);
    }
    void doMoveInPlace(const Color c, const Move move) {
        (c == Black) ? doMoveSub<Black>(move) : doMoveSub<White>(move);
    }
    template <Color C>
    void doNullMoveSub();
    template <Color C>
    void doNullMove() {
        *static_cast<PositionMin *>(&next()) = *this;
        next().doNullMoveSub<C>();
    }

    //牺͑xsv

    //߂ ʏ͎gȂ
    void undoMove(const Color c, const Move move);
    //ՏɂɂȂԂɂ
    void clear();
    //byColorBB_, piece_, hand_, root_turn_Position
    void normalize();
    //ǖʂUSI`ɕϊ
    std::string toUSI() const;
    std::string toKifu() const;
};

forceinline constexpr int Lva(const PieceType p) {
    //4bit16̒lĂ
    return 0x45689cdf12379abf >> p * 4 & 0xf;
}

//ԂɂƂēGwrankiڂ܂łɂ邩
template <int Rank = PromotionRank>
forceinline bool PromotionZone(const Color c, const Square sq) {
    return (c == Black) ?
        sq < Rank * FileNum :
        sq >= (RankNum - Rank) * FileNum;
}

forceinline constexpr int RankInv(const Color c, const int rank) {
    return (c == Black) ? rank : RankNum - 1 - rank;
}

//𓾂 0nꍇ͉ԂĂ邩킩Ȃ
template <class T>
forceinline constexpr int Sign(const T i) {
    return (i > 0) ? 1 : -1;
}

forceinline constexpr int ColorToSign(const Color c) {
    return (c == Black) ? 1 : -1;
}

forceinline constexpr PieceType CvtIfGolds(const PieceType p) {
    return (p > ProGold) ? Golds : p;
}

//constexpr uint8_t CanPromoteArray[PieceTypeNum] = { 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0 };
forceinline constexpr bool CanPromote(const PieceType p) {
    //return CanPromoteArray[p] != 0;//ANZXƂ͂[hꔭōςނ̂͑
    //return (p < HandTypeNum && p != Gold && p != King);//ɂ
    return ((1 << Rook | 1 << Bishop | 1 << Silver | 1 << Knight | 1 << Lance | 1 << Pawn) & 1 << p) != 0;//萔Vtg͒x̂Ȃ
}

forceinline constexpr bool IsSlider(const PieceType p) {
    return ((1 << Rook | 1 << Bishop | 1 << Lance | 1 << Dragon | 1 << Horse) & 1 << p) != 0;
}

template <class F>
forceinline void for_each_bb(const Bitboard& b, F f) {
    assert((b & ~InFrontBB[Black][RankNum]).isNone());
    unsigned long index;
    for (uint64_t m = b.b64(0); _BitScanForward64(&index, m); m &= m - 1) {
        f(static_cast<Square>(index));
    }
    for (uint64_t m = b.b64(1); _BitScanForward64(&index, m); m &= m - 1) {
        f(static_cast<Square>(index + SquareSecond));
    }
}

template <class F>
forceinline bool any_of_bb(const Bitboard& b, F f) {
    assert((b & ~InFrontBB[Black][RankNum]).isNone());
    unsigned long index;
    for (uint64_t m = b.b64(0); _BitScanForward64(&index, m); m &= m - 1) {
        if (f(static_cast<Square>(index))) return true;
    }
    for (uint64_t m = b.b64(1); _BitScanForward64(&index, m); m &= m - 1) {
        if (f(static_cast<Square>(index + SquareSecond))) return true;
    }
    return false;
}

template <PieceType P>
struct NPieceType {
    static constexpr PieceType value = P;
};

template <bool ExceptKing = false, class F>
forceinline void for_each_piece(F f) {
    f(NPieceType<Pawn>{});
    f(NPieceType<Lance>{});
    f(NPieceType<Knight>{});
    f(NPieceType<Silver>{});
    f(NPieceType<Golds>{});
    f(NPieceType<Bishop>{});
    f(NPieceType<Rook>{});
    f(NPieceType<Horse>{});
    f(NPieceType<Dragon>{});
    if (!ExceptKing) f(NPieceType<King>{});
}

template <bool ExceptKing = false, class F>
forceinline bool any_of_piece(F f) {
    if (!ExceptKing && f(NPieceType<King>{})) return true;
    if (f(NPieceType<Dragon>{})) return true;
    if (f(NPieceType<Horse>{})) return true;
    if (f(NPieceType<Rook>{})) return true;
    if (f(NPieceType<Bishop>{})) return true;
    if (f(NPieceType<Golds>{})) return true;
    if (f(NPieceType<Silver>{})) return true;
    if (f(NPieceType<Knight>{})) return true;
    if (f(NPieceType<Lance>{})) return true;
    if (f(NPieceType<Pawn>{})) return true;
    return false;
}

template <class F>
forceinline bool any_of_promotion(F f) {
    if (f(NPieceType<HandTypeNum>{})) return true;
    if (f(NPieceType<PieceTypeNone>{})) return true;//sɂ
    return false;
}

// łĂꏊԂ
forceinline Bitboard pawn_file_bb(const Color c, const Position& pos) {
    const Bitboard b = pos.byTypeBB_[Pawn] & pos.byColorBB_[c];
    uint64_t u = b.b64(0);
    u |= u >> FileNum * 4 | b.b64(1) << SquareSecond % FileNum;
    u |= u >> FileNum * 2;
    u |= u >> FileNum;
    return PawnFileBB[u & MaskBits(0, FileNum)];
}
forceinline bool pawn_dropable(const Square to, const Bitboard& pawnBB) {
    return (pawnBB & FileBB[to % FileNum]).isNone();
}

forceinline Bitboard sliding_attacks_to_edge_bb(Color c, Square sq, PieceType p) {
    switch (p) {
        case Lance:
            return SlidingAttacksBB[sq][SlidingTypeNum + c][0];
        case Rook:
        case Dragon:
            return SlidingAttacksBB[sq][0][0] | SlidingAttacksBB[sq][1][0];
        case Bishop:
        case Horse:
            return SlidingAttacksBB[sq][2][0] | SlidingAttacksBB[sq][3][0];
        default:
            __assume(0);
    }
}

//ї occgsq̕j(0:c, 1:, 2:_, 3:^, 4:̍, 5:̍)̗𓾂
forceinline Bitboard sliding_attacks_bb(int sq, int j, const Occupied& occ) {
    const int j_ = (j < SlidingTypeNum) ? j : 0;
    uint64_t k = occ.b64(j_) >> OccShift[sq][j_] & MaskBits(0, FileNum - 2);
    return SlidingAttacksBB[sq][j][k];
}

forceinline Bitboard step_attacks_bb(Color c, PieceType p, Square sq) {
    assert(p != HandTypeNum && p < ProGold);
    return StepAttacksBB[c][p][sq];
}

forceinline Bitboard attacks_bb(Color c, Square sq, PieceType p, const Occupied& occ) {
    switch (p) {
        case Dragon:
            return sliding_attacks_bb(sq, 0, occ) | sliding_attacks_bb(sq, 1, occ) | StepAttacksBB[0][King][sq];
        case Rook:
            return sliding_attacks_bb(sq, 0, occ) | sliding_attacks_bb(sq, 1, occ);
        case Horse:
            return sliding_attacks_bb(sq, 2, occ) | sliding_attacks_bb(sq, 3, occ) | StepAttacksBB[0][King][sq];
        case Bishop:
            return sliding_attacks_bb(sq, 2, occ) | sliding_attacks_bb(sq, 3, occ);
        case Lance:
            return sliding_attacks_bb(sq, SlidingTypeNum + c, occ);
        default:
            assert(p != HandTypeNum && p < ProGold);
            return step_attacks_bb(c, p, sq);
    }
}

//Bitboard̒ŎC̗Ȃł邩
template <Color C>
forceinline bool canKingEscape(const Position& pos, const Bitboard& b, const Occupied& occupied) {
    return any_of_bb(b, [&](const Square escape_to) {
        return pos.attackersTo<C>(escape_to, occupied).isNone();
    });
}
