
#include "position.h"

template <Color C>
Score Position::see(const Move move, const int threshold) const {
    Occupied occupied;
    Bitboard attackers[ColorNum];//toւ̗eԂ̋
    Bitboard doneBB;//to֓tȍꏊ
    Score swap_list[21];
    PieceType captured;
    const Square to = move.to();//̏Ŏ荇s
    Square from = move.from();

    if (from < SquareNum) {
        //ړ
        //ʂړꍇAtoɑ̗͂Ȃ(ۂ͉uǂނȂ)
        if (move.piece() == King) return CapturePieceScore[move.cap()];

        occupied = occupied_ ^ SquareOcc[from];
        const Score score = add_if(CapturePieceScore[move.cap()], move.isPromotion(), PromotePieceScore[move.piece()]);
        attackers[OppositeColor(C)] = attackersTo<OppositeColor(C)>(to, occupied);
        if (attackers[OppositeColor(C)].isNone()) return score;
        if (score < threshold) return score;

        swap_list[0] = score;//SEE̒l͍Xswap_list[0]ɂȂȂ
        captured = add_if(move.piece(), move.isPromotion(), HandTypeNum);
        doneBB = SquareBB[to] ^ SquareBB[from];
        occupied |= SquareOcc[to];

    } else {
        //ł
        attackers[OppositeColor(C)] = attackersTo<OppositeColor(C)>(to, occupied_);
        if (attackers[OppositeColor(C)].isNone()) return ScoreZero;
        if (ScoreZero < threshold) return ScoreZero;

        swap_list[0] = ScoreZero;
        captured = static_cast<PieceType>(from - SquareNum);
        doneBB = ZeroBB;
        occupied = occupied_ | SquareOcc[to];
    }

    Color turn = OppositeColor(C);
    int sl_index = 0;

    for (uint64_t n; (n = attackers[turn].popcnt()) > 0;) {
        //lŏ̋I
        if (n == 1) {
            any_of_bb(attackers[turn], [&](const Square sq) {
                from = sq;
                return true;
            });
        } else {
            int t_min = 0x10;
            for_each_bb(attackers[turn], [&](const Square sq) {
                int t = Lva(piece_[sq]);
                if (t < t_min) {
                    from = sq;
                    t_min = t;
                }
            });
        }

        //fromtoֈړĎԂ
        const PieceType piece = piece_[from];
        const bool promotion = CanPromote(piece) && (PromotionZone(turn, to) || PromotionZone(turn, from));
        const Score score = add_if(CapturePieceScore[captured], promotion, PromotePieceScore[piece]);
        swap_list[sl_index + 1] = -swap_list[sl_index] + score;

        //݂̐[臒l̂ǂ瑤킩甲 Ă邩͔
        if ((ColorToSign(C) * ColorToSign(turn) * swap_list[sl_index + 1] < threshold) ^ (turn != C)) break;

        if (sl_index == 0/*߂ĂɗƂ*/) attackers[C] = attackersTo<C>(to, occupied) & ~doneBB;
        if (piece == King) {
            //ʂɑ̗͂Ȃ̂ŉBꂽ̗͊mFȂĂ
            if (attackers[OppositeColor(turn)].isNone()) ++sl_index;//܋ʂŎ͗L
            break;
        }

        attackers[turn] ^= SquareBB[from];
        doneBB ^= SquareBB[from];
        occupied ^= SquareOcc[from];//͏attackers[C]ɂĂAǂ̉Aׂ͒Kv̂
        captured = add_if(piece, promotion, HandTypeNum);

        ++sl_index;
        turn = OppositeColor(turn);

        //ړ̉AɂȂĂ𓾂
        const int d = Direction[to][from];
        if (d != 0) {
            Bitboard behindBB;
            switch (abs(d)) {
                case SlidingStep[0]:
                    behindBB = sliding_attacks_bb(from, 0, occupied) & (byTypeBB_[Rook] | byTypeBB_[Dragon] | (byTypeBB_[Lance] & byColorBB_[(from < to)]));
                    break;
                case SlidingStep[1]:
                    behindBB = sliding_attacks_bb(from, 1, occupied) & (byTypeBB_[Rook] | byTypeBB_[Dragon]);
                    break;
                case SlidingStep[2]:
                    behindBB = sliding_attacks_bb(from, 2, occupied) & (byTypeBB_[Bishop] | byTypeBB_[Horse]);
                    break;
                case SlidingStep[3]:
                    behindBB = sliding_attacks_bb(from, 3, occupied) & (byTypeBB_[Bishop] | byTypeBB_[Horse]);
                    break;
                default:
                    __assume(0);
            }
            behindBB &= ~doneBB;//𕜊Ȃ
#ifdef DEBUG
            if (behindBB.popcnt() > 1) {
                std::cout << this->toUSI() << "\n" << move.toUSI() << std::endl;
                assert(0);
            }
#endif
            if (!behindBB.isNone()) {
                attackers[Black] |= behindBB & byColorBB_[Black];
                attackers[White] |= behindBB & byColorBB_[White];
            }
        }
    }

#ifdef SEE_TEST
    for (int i = 0; i <= sl_index; ++i) {
        std::cout << swap_list[i] << " ";
    }
    std::cout << sl_index + 1 << " ";
#endif

    while (sl_index--) swap_list[sl_index] = std::min(swap_list[sl_index], -swap_list[sl_index + 1]);
    return swap_list[0];
}
template Score Position::see<Black>(const Move move, const int threshold) const;
template Score Position::see<White>(const Move move, const int threshold) const;

template <Color C>
bool Position::seeSign(const Move move, const int threshold) const {
    //ȂԂꂽƂƂ́A܂
    if (move.isCapture() && CapturePieceScore[move.cap()] - CapturePieceScore[move.piece()] >= threshold) return true;
    return see<C>(move, threshold) >= threshold;
}
template bool Position::seeSign<Black>(const Move move, const int threshold) const;
template bool Position::seeSign<White>(const Move move, const int threshold) const;

template <Color C>
bool Position::moveIsPseudoLegal(const Move move) const {
    const Square from = move.from();
    const Square to = move.to();

    if (from < SquareNum) {
        //ړ
        const PieceType piece = move.piece();
        if (piece_[from] != piece || !byColorBB_[C].isSet(from)) return false;
        if (move.isCapture()) {
            if (piece_[to] != move.cap() || !byColorBB_[OppositeColor(C)].isSet(to)) return false;
        } else {
            if (!byTypeBB_[Empty].isSet(to)) return false;//piece_[to]Ăʂ肪rłȂ
        }
        if (piece == Lance || piece % HandTypeNum == Rook || piece % HandTypeNum == Bishop) {
            if (!(BetweenBB[from][to] & ~byTypeBB_[Empty]).isNone()) return false;
        }

        if (checked_ && piece != King) {
            if (checked_ > 1) return false;
            if (!(BetweenBB[king_[C]][checker_] ^ SquareBB[checker_]).isSet(to)) return false;
        }

    } else {
        //ł
        const PieceType piece = static_cast<PieceType>(from - SquareNum);
        if (hand_[C][piece] == 0 || !byTypeBB_[Empty].isSet(to)) return false;
        if (piece == Pawn && !pawn_dropable(to, byTypeBB_[Pawn] & byColorBB_[C])) return false;

        if (checked_) {
            if (checked_ > 1) return false;//
            if (!BetweenBB[king_[C]][checker_].isSet(to)) return false;
        }
    }

    return true;
}
template bool Position::moveIsPseudoLegal<Black>(const Move move) const;
template bool Position::moveIsPseudoLegal<White>(const Move move) const;
