
#include <stdio.h>
#include <stdarg.h>
#include <thread>
#include <iostream>

#include "util.h"

//_/RA
unsigned int hardware_concurrency() {
	return std::thread::hardware_concurrency();
}

#ifdef _WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

unsigned int physical_concurrency() {
	bool SMT = false;
	DWORD ReturnedLength = 0;
	BOOL ret = GetLogicalProcessorInformationEx(RelationProcessorCore, nullptr, &ReturnedLength);
	if (ret == FALSE && GetLastError() == ERROR_INSUFFICIENT_BUFFER){
		auto Buffer = (PSYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX)HeapAlloc(GetProcessHeap(), 0, ReturnedLength);
		ret = GetLogicalProcessorInformationEx(RelationProcessorCore, Buffer, &ReturnedLength);
		if (ret && Buffer && Buffer->Processor.Flags == LTP_PC_SMT) SMT = true;
		HeapFree(GetProcessHeap(), 0, Buffer);
	}
	return hardware_concurrency() / (SMT ? 2 : 1);
}

//vZX̗D揇ʂ(wKɂPCg)
bool set_low_priority() {
	return SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS) != FALSE;
}

#endif
